Index: src/CodeGen/Generate.cc
===================================================================
--- src/CodeGen/Generate.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/CodeGen/Generate.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -41,5 +41,5 @@
 		void cleanTree( std::list< Declaration * > & translationUnit ) {
 			PassVisitor<TreeCleaner> cleaner;
-			filter( translationUnit, [](Declaration * decl) { return TreeCleaner::shouldClean(decl); }, false );
+			filter( translationUnit, [](Declaration * decl) { return TreeCleaner::shouldClean(decl); } );
 			mutateAll( translationUnit, cleaner );
 		} // cleanTree
@@ -79,5 +79,5 @@
 				}
 				return false;
-			}, false );
+			} );
 		}
 
@@ -85,5 +85,4 @@
 			Statement * callStmt = nullptr;
 			std::swap( stmt->callStmt, callStmt );
-			delete stmt;
 			return callStmt;
 		}
Index: src/Common/GC.cc
===================================================================
--- src/Common/GC.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
+++ src/Common/GC.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -0,0 +1,111 @@
+//
+// Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
+//
+// The contents of this file are covered under the licence agreement in the
+// file "LICENCE" distributed with Cforall.
+//
+// GC.cc --
+//
+// Author           : Aaron B. Moss
+// Created On       : Thu Mar 15 14:47:00 2018
+// Last Modified By : Aaron B. Moss
+// Last Modified On : Thu Mar 15 14:47:00 2018
+// Update Count     : 1
+//
+
+#include "GC.h"
+
+#include <algorithm>
+
+GC& GC::get() {
+	static GC gc;
+	return gc;
+}
+
+GC::GC() : mark(false), old(), young(), using_young(false) {
+	old.reserve(70000);
+}
+
+GC::~GC() {
+	for ( GC_Object* o : young ) {
+		delete o;
+	}
+
+	for ( GC_Object* o : old ) {
+		delete o;
+	}
+}
+
+const GC& GC::operator<< (const GC_Traceable* obj) const {
+	if( obj )
+	{
+		bool isMarked = obj->mark == this->mark;
+		if( !isMarked ) {
+			obj->mark = this->mark;
+			obj->trace( *this );
+		}
+	}
+	return *this;
+}
+
+void GC::register_object(GC_Object* obj) {
+	(using_young ? young : old).push_back(obj);
+	obj->mark = this->mark;
+}
+
+void GC::new_generation() {
+	using_young = true;
+}
+
+void GC::collect_young() {
+	// check young generation, just reset mark if not using
+	if ( ! using_young ) {
+		mark = !mark;
+		return;
+	}
+
+	// collect young gen
+	for ( GC_Object*& obj : young ) {
+		if ( obj->mark != mark ) {
+			delete obj;
+			obj = nullptr;
+		}
+	}
+	
+	// move uncollected elements into old gen
+	auto end_live = std::remove( young.begin(), young.end(), nullptr );
+	old.insert( old.end(), young.begin(), end_live );
+	
+	// clear young gen
+	using_young = false;
+	young.clear();
+
+	// reset mark for next collection
+	mark = !mark;
+}
+
+void GC::collect() {
+	// collect old gen
+	for ( GC_Object*& obj : old ) {
+		if ( obj->mark != mark ) {
+			delete obj;
+			obj = nullptr;
+		}
+	}
+
+	// clear collected elements
+	old.erase( std::remove( old.begin(), old.end(), nullptr ), old.end() );
+
+	// collect young gen (also resets mark)
+	collect_young();
+}
+
+GC_Object::GC_Object() {
+	GC::get().register_object( this );
+}
+
+// Local Variables: //
+// tab-width: 4 //
+// mode: c++ //
+// compile-command: "make install" //
+// End: //
Index: src/Common/GC.h
===================================================================
--- src/Common/GC.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
+++ src/Common/GC.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -0,0 +1,117 @@
+//
+// Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
+//
+// The contents of this file are covered under the licence agreement in the
+// file "LICENCE" distributed with Cforall.
+//
+// GC.h --
+//
+// Author           : Aaron B. Moss
+// Created On       : Thu Mar 15 14:47:00 2018
+// Last Modified By : Aaron B. Moss
+// Last Modified On : Thu Mar 15 14:47:00 2018
+// Update Count     : 1
+//
+
+#pragma once
+
+#include <vector>
+
+class GC_Traceable;
+class GC_Object;
+
+/// Manually traced and called garbage collector
+class GC {
+	friend class GcTracer;
+public:
+	/// Gets singleton GC instance
+	static GC& get();
+
+	/// Traces a traceable object
+	const GC& operator<< (const GC_Traceable*) const;
+
+	/// Adds a new object to garbage collection
+	void register_object(GC_Object*);
+
+	/// Use young generation for subsequent new objects
+	void new_generation();
+
+	/// Collects the young generation, placing survivors in old generation.
+	/// Old generation is used for subsequent new objects.
+	void collect_young();
+
+	/// Collects all memory; use old generation afterward.
+	void collect();
+
+	/// Collects all contained objects
+	~GC();
+
+private:
+	GC();
+
+	/// The current collection's mark bit
+	bool mark;
+
+	typedef std::vector<class GC_Object*> Generation;
+	Generation old;
+	Generation young;
+	bool using_young;
+};
+
+/// Use young generation until next collection
+inline void new_generation() { GC::get().new_generation(); }
+
+/// no-op default trace
+template<typename T>
+inline const GC& operator<< (const GC& gc, const T& x) { return gc; }
+
+inline void traceAll(const GC& gc) {}
+
+/// Marks all arguments as live in current generation
+template<typename T, typename... Args>
+inline void traceAll(const GC& gc, T& x, Args&... xs) {
+	gc << x;
+	traceAll(gc, xs...);
+}
+
+/// Traces young-generation roots and does a young collection
+template<typename... Args>
+inline void collect_young(Args&... roots) {
+	GC& gc = GC::get();
+	traceAll(gc, roots...);
+	gc.collect_young();
+}
+
+/// Traces roots and collects other elements
+template<typename... Args>
+inline void collect(Args&... roots) {
+	GC& gc = GC::get();
+	traceAll(gc, roots...);
+	gc.collect();
+}
+
+/// Class that is traced by the GC, but not managed by it
+class GC_Traceable {
+	friend class GC;
+	friend class GcTracer;
+
+	mutable bool mark;
+protected:
+	/// override to trace any child objects
+	virtual void trace(const GC& gc) const {}
+};
+
+/// Class that is managed by the GC
+class GC_Object : public GC_Traceable {
+	friend class GC;
+protected:
+	virtual ~GC_Object() {}
+public:
+	GC_Object();
+};
+
+// Local Variables: //
+// tab-width: 4 //
+// mode: c++ //
+// compile-command: "make install" //
+// End: //
Index: src/Common/PassVisitor.h
===================================================================
--- src/Common/PassVisitor.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Common/PassVisitor.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -152,4 +152,6 @@
 	virtual void visit( Attribute * attribute ) override final;
 
+	virtual void visit( TypeSubstitution * sub ) final;
+
 	virtual DeclarationWithType * mutate( ObjectDecl * objectDecl ) override final;
 	virtual DeclarationWithType * mutate( FunctionDecl * functionDecl ) override final;
Index: src/Common/PassVisitor.impl.h
===================================================================
--- src/Common/PassVisitor.impl.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Common/PassVisitor.impl.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -2556,4 +2556,18 @@
 // TypeSubstitution
 template< typename pass_type >
+void PassVisitor< pass_type >::visit( TypeSubstitution * node ) {
+	VISIT_START( node );
+
+	for ( auto & p : node->typeEnv ) {
+		indexerScopedAccept( p.second, *this );
+	}
+	for ( auto & p : node->varEnv ) {
+		indexerScopedAccept( p.second, *this );
+	}
+
+	VISIT_END( node );
+}
+
+template< typename pass_type >
 TypeSubstitution * PassVisitor< pass_type >::mutate( TypeSubstitution * node ) {
 	MUTATE_START( node );
Index: src/Common/module.mk
===================================================================
--- src/Common/module.mk	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Common/module.mk	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -18,3 +18,4 @@
        Common/UniqueName.cc \
        Common/DebugMalloc.cc \
+       Common/GC.cc \
        Common/Assert.cc
Index: src/Common/utility.h
===================================================================
--- src/Common/utility.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Common/utility.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -190,12 +190,9 @@
 
 template <typename E, typename UnaryPredicate, template< typename, typename...> class Container, typename... Args >
-void filter( Container< E *, Args... > & container, UnaryPredicate pred, bool doDelete ) {
+void filter( Container< E *, Args... > & container, UnaryPredicate pred ) {
 	auto i = begin( container );
 	while ( i != end( container ) ) {
 		auto it = next( i );
 		if ( pred( *i ) ) {
-			if ( doDelete ) {
-				delete *i;
-			} // if
 			container.erase( i );
 		} // if
Index: src/Concurrency/Keywords.cc
===================================================================
--- src/Concurrency/Keywords.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Concurrency/Keywords.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -291,5 +291,4 @@
 		StructDecl * forward = decl->clone();
 		forward->set_body( false );
-		deleteAll( forward->get_members() );
 		forward->get_members().clear();
 
@@ -355,6 +354,4 @@
 			fixupGenerics(main_type, decl);
 		}
-
-		delete this_decl;
 
 		declsToAddBefore.push_back( forward );
Index: src/Concurrency/Waitfor.cc
===================================================================
--- src/Concurrency/Waitfor.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Concurrency/Waitfor.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -476,6 +476,4 @@
 		}
 
-		delete setter;
-
 		return new VariableExpr( timeout );
 	}
Index: src/ControlStruct/ExceptTranslate.cc
===================================================================
--- src/ControlStruct/ExceptTranslate.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ControlStruct/ExceptTranslate.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -204,5 +204,4 @@
 		call->get_args().push_back( throwStmt->get_expr() );
 		throwStmt->set_expr( nullptr );
-		delete throwStmt;
 		return new ExprStmt( call );
 	}
@@ -234,5 +233,4 @@
 			new UntypedExpr( new NameExpr( "__cfaabi_ehm__rethrow_terminate" ) )
 			) );
-		delete throwStmt;
 		return result;
 	}
@@ -251,5 +249,4 @@
 			);
 		result->labels = throwStmt->labels;
-		delete throwStmt;
 		return result;
 	}
@@ -384,5 +381,4 @@
 		modded_handler->set_cond( nullptr );
 		modded_handler->set_body( nullptr );
-		delete modded_handler;
 		return block;
 	}
@@ -530,5 +526,4 @@
 		CompoundStmt * body = finally->get_block();
 		finally->set_block( nullptr );
-		delete finally;
 		tryStmt->set_finally( nullptr );
 
Index: src/ControlStruct/MLEMutator.cc
===================================================================
--- src/ControlStruct/MLEMutator.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ControlStruct/MLEMutator.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -151,5 +151,4 @@
 
 		// transform break/continue statements into goto to simplify later handling of branches
-		delete branchStmt;
 		return new BranchStmt( exitLabel, BranchStmt::Goto );
 	}
Index: src/GenPoly/Box.cc
===================================================================
--- src/GenPoly/Box.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/GenPoly/Box.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -860,9 +860,7 @@
 			// do not carry over attributes to real type parameters/return values
 			for ( DeclarationWithType * dwt : realType->parameters ) {
-				deleteAll( dwt->get_type()->attributes );
 				dwt->get_type()->attributes.clear();
 			}
 			for ( DeclarationWithType * dwt : realType->returnVals ) {
-				deleteAll( dwt->get_type()->attributes );
 				dwt->get_type()->attributes.clear();
 			}
@@ -985,5 +983,4 @@
 			} // if
 			appExpr->get_args().clear();
-			delete appExpr;
 			return addAssign;
 		}
@@ -1016,5 +1013,4 @@
 						} // if
 						if ( baseType1 || baseType2 ) {
-							delete ret->get_result();
 							ret->set_result( appExpr->get_result()->clone() );
 							if ( appExpr->get_env() ) {
@@ -1023,5 +1019,4 @@
 							} // if
 							appExpr->get_args().clear();
-							delete appExpr;
 							return ret;
 						} // if
@@ -1033,5 +1028,4 @@
 							Expression *ret = appExpr->get_args().front();
 							// fix expr type to remove pointer
-							delete ret->get_result();
 							ret->set_result( appExpr->get_result()->clone() );
 							if ( appExpr->get_env() ) {
@@ -1040,5 +1034,4 @@
 							} // if
 							appExpr->get_args().clear();
-							delete appExpr;
 							return ret;
 						} // if
@@ -1180,5 +1173,4 @@
 						Expression *ret = expr->args.front();
 						expr->args.clear();
-						delete expr;
 						return ret;
 					} // if
@@ -1214,8 +1206,6 @@
 			if ( polytype || needs ) {
 				Expression *ret = addrExpr->arg;
-				delete ret->result;
 				ret->result = addrExpr->result->clone();
 				addrExpr->arg = nullptr;
-				delete addrExpr;
 				return ret;
 			} else {
@@ -1227,5 +1217,4 @@
 			if ( retval && returnStmt->expr ) {
 				assert( returnStmt->expr->result && ! returnStmt->expr->result->isVoid() );
-				delete returnStmt->expr;
 				returnStmt->expr = nullptr;
 			} // if
@@ -1270,5 +1259,4 @@
 				}
 			}
-//  deleteAll( functions );
 		}
 
@@ -1290,5 +1278,4 @@
 			for ( Declaration * param : functionDecl->type->parameters ) {
 				if ( ObjectDecl * obj = dynamic_cast< ObjectDecl * >( param ) ) {
-					delete obj->init;
 					obj->init = nullptr;
 				}
@@ -1499,7 +1486,5 @@
 							// polymorphic aggregate members should be converted into monomorphic members.
 							// Using char[size_T] here respects the expected sizing rules of an aggregate type.
-							Type * newType = polyToMonoType( field->type );
-							delete field->type;
-							field->type = newType;
+							field->type = polyToMonoType( field->type );
 						}
 					}
@@ -1524,5 +1509,4 @@
 					stmtsToAddBefore.push_back( new DeclStmt( newBuf ) );
 
-					delete objectDecl->get_init();
 					objectDecl->set_init( new SingleInit( new VariableExpr( newBuf ) ) );
 				}
@@ -1603,6 +1587,4 @@
 			}
 
-			delete memberType;
-			delete memberExpr;
 			return newMemberExpr;
 		}
@@ -1624,5 +1606,4 @@
 						addrExpr->arg = nullptr;
 						std::swap( addrExpr->env, ret->env );
-						delete addrExpr;
 						return ret;
 					}
@@ -1750,7 +1731,5 @@
 			Type *ty = sizeofExpr->get_isType() ? sizeofExpr->get_type() : sizeofExpr->get_expr()->get_result();
 			if ( findGeneric( ty ) ) {
-				Expression *ret = new NameExpr( sizeofName( mangleType( ty ) ) );
-				delete sizeofExpr;
-				return ret;
+				return new NameExpr( sizeofName( mangleType( ty ) ) );
 			}
 			return sizeofExpr;
@@ -1760,7 +1739,5 @@
 			Type *ty = alignofExpr->get_isType() ? alignofExpr->get_type() : alignofExpr->get_expr()->get_result();
 			if ( findGeneric( ty ) ) {
-				Expression *ret = new NameExpr( alignofName( mangleType( ty ) ) );
-				delete alignofExpr;
-				return ret;
+				return new NameExpr( alignofName( mangleType( ty ) ) );
 			}
 			return alignofExpr;
@@ -1777,10 +1754,7 @@
 				if ( i == -1 ) return offsetofExpr;
 
-				Expression *offsetInd = makeOffsetIndex( ty, i );
-				delete offsetofExpr;
-				return offsetInd;
+				return makeOffsetIndex( ty, i );
 			} else if ( dynamic_cast< UnionInstType* >( ty ) ) {
 				// all union members are at offset zero
-				delete offsetofExpr;
 				return new ConstantExpr( Constant::from_ulong( 0 ) );
 			} else return offsetofExpr;
@@ -1822,5 +1796,4 @@
 			}
 
-			delete offsetPackExpr;
 			return ret;
 		}
Index: src/GenPoly/InstantiateGeneric.cc
===================================================================
--- src/GenPoly/InstantiateGeneric.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/GenPoly/InstantiateGeneric.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -58,6 +58,4 @@
 
 		TypeList& operator= ( const TypeList &that ) {
-			deleteAll( params );
-
 			params.clear();
 			cloneAll( that.params, params );
@@ -67,6 +65,4 @@
 
 		TypeList& operator= ( TypeList &&that ) {
-			deleteAll( params );
-
 			params = std::move( that.params );
 
@@ -74,5 +70,5 @@
 		}
 
-		~TypeList() { deleteAll( params ); }
+		~TypeList() {}
 
 		bool operator== ( const TypeList& that ) const {
@@ -293,5 +289,4 @@
 	/// Strips the instances's type parameters
 	void stripInstParams( ReferenceToType *inst ) {
-		deleteAll( inst->get_parameters() );
 		inst->get_parameters().clear();
 	}
@@ -300,6 +295,4 @@
 		substituteMembers( base->get_members(), baseParams, typeSubs );
 
-		// xxx - can't delete type parameters because they may have assertions that are used
-		// deleteAll( baseParams );
 		baseParams.clear();
 
@@ -380,5 +373,4 @@
 			newInst->set_baseStruct( concDecl );
 
-			delete inst;
 			inst = newInst;
 			break;
@@ -390,5 +382,4 @@
 		}
 
-		deleteAll( typeSubs );
 		return inst;
 	}
@@ -430,5 +421,4 @@
 			newInst->set_baseUnion( concDecl );
 
-			delete inst;
 			inst = newInst;
 			break;
@@ -439,5 +429,4 @@
 		}
 
-		deleteAll( typeSubs );
 		return inst;
 	}
@@ -477,5 +466,4 @@
 			ResolvExpr::adjustExprType( ret->result ); // pointer decay
 			std::swap( ret->env, memberExpr->env );
-			delete memberExpr;
 			return ret;
 		}
Index: src/GenPoly/Lvalue.cc
===================================================================
--- src/GenPoly/Lvalue.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/GenPoly/Lvalue.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -50,5 +50,4 @@
 				assertf( base, "expected pointer type in dereference (type was %s)", toString( arg->result ).c_str() );
 				ApplicationExpr * ret = new ApplicationExpr( deref, { arg } );
-				delete ret->result;
 				ret->result = base->clone();
 				ret->result->set_lvalue( true );
@@ -171,5 +170,4 @@
 					return ret;
 				}
-				delete result;
 			}
 			return appExpr;
@@ -214,7 +212,5 @@
 							Type * baseType = InitTweak::getPointerBase( arg->get_result() );
 							assertf( baseType, "parameter is reference, arg must be pointer or reference: %s", toString( arg->get_result() ).c_str() );
-							PointerType * ptrType = new PointerType( Type::Qualifiers(), baseType->clone() );
-							delete arg->get_result();
-							arg->set_result( ptrType );
+							arg->set_result( new PointerType{ Type::Qualifiers(), baseType->clone() } );
 							arg = mkDeref( arg );
 						}
@@ -294,5 +290,4 @@
 						)
 						callExpr = new AddressExpr( callExpr ); // this doesn't work properly for multiple casts
-						delete callExpr->get_result();
 						callExpr->set_result( refType->clone() );
 						// move environment out to new top-level
@@ -300,5 +295,4 @@
 						castExpr->set_arg( nullptr );
 						castExpr->set_env( nullptr );
-						delete castExpr;
 						return callExpr;
 					}
@@ -318,5 +312,4 @@
 						}
 						ret->env = castExpr->env;
-						delete ret->result;
 						ret->result = castExpr->result;
 						ret->result->set_lvalue( true ); // ensure result is lvalue
@@ -324,5 +317,4 @@
 						castExpr->arg = nullptr;
 						castExpr->result = nullptr;
-						delete castExpr;
 						return ret;
 					} else if ( diff > 0 ) {
@@ -333,10 +325,8 @@
 						}
 						ret->env = castExpr->env;
-						delete ret->result;
 						ret->result = castExpr->result;
 						castExpr->env = nullptr;
 						castExpr->arg = nullptr;
 						castExpr->result = nullptr;
-						delete castExpr;
 						return ret;
 					}
@@ -360,10 +350,8 @@
 					}
 					ret->env = castExpr->env;
-					delete ret->result;
 					ret->result = castExpr->result;
 					castExpr->env = nullptr;
 					castExpr->arg = nullptr;
 					castExpr->result = nullptr;
-					delete castExpr;
 					return ret;
 				} else {
@@ -390,5 +378,4 @@
 					ret->result->set_lvalue( true );  // ensure result is lvalue
 					castExpr->arg = nullptr;
-					delete castExpr;
 				} else {
 					// must keep cast if types are different
@@ -407,5 +394,4 @@
 			Type::Qualifiers qualifiers = refType->get_qualifiers();
 			refType->set_base( nullptr );
-			delete refType;
 			return new PointerType( qualifiers, base );
 		}
@@ -419,5 +405,4 @@
 				ret->set_env( expr->get_env() );
 				expr->set_env( nullptr );
-				delete expr;
 				return ret;
 			} else if ( ConditionalExpr * condExpr = dynamic_cast< ConditionalExpr * >( arg ) ) {
@@ -428,5 +413,4 @@
 				ret->set_env( expr->get_env() );
 				expr->set_env( nullptr );
-				delete expr;
 
 				// conditional expr type may not be either of the argument types, need to unify
@@ -461,5 +445,4 @@
 					arg0 = nullptr;
 					addrExpr->set_env( nullptr );
-					delete addrExpr;
 					return ret;
 				}
@@ -491,5 +474,4 @@
 						addrExpr->set_arg( nullptr );
 						appExpr->set_env( nullptr );
-						delete appExpr;
 						return ret;
 					}
Index: src/GenPoly/ScrubTyVars.cc
===================================================================
--- src/GenPoly/ScrubTyVars.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/GenPoly/ScrubTyVars.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -28,10 +28,7 @@
 		if ( ! tyVars ) {
 			if ( typeInst->get_isFtype() ) {
-				delete typeInst;
-				return new PointerType( Type::Qualifiers(), new FunctionType( Type::Qualifiers(), true ) );
+				return new PointerType{ Type::Qualifiers(), new FunctionType( Type::Qualifiers(), true ) };
 			} else {
-				PointerType * ret = new PointerType( Type::Qualifiers(), new VoidType( typeInst->get_qualifiers() ) );
-				delete typeInst;
-				return ret;
+				return new PointerType{ Type::Qualifiers(), new VoidType( typeInst->get_qualifiers() ) };
 			}
 		}
@@ -42,12 +39,7 @@
 			  case TypeDecl::Dtype:
 			  case TypeDecl::Ttype:
-				{
-					PointerType * ret = new PointerType( Type::Qualifiers(), new VoidType( typeInst->get_qualifiers() ) );
-					delete typeInst;
-					return ret;
-				}
+				return new PointerType{ Type::Qualifiers(), new VoidType( typeInst->get_qualifiers() ) };
 			  case TypeDecl::Ftype:
-				delete typeInst;
-				return new PointerType( Type::Qualifiers(), new FunctionType( Type::Qualifiers(), true ) );
+				return new PointerType{ Type::Qualifiers(), new FunctionType( Type::Qualifiers(), true ) };
 			} // switch
 		} // if
@@ -57,7 +49,5 @@
 	Type * ScrubTyVars::mutateAggregateType( Type * ty ) {
 		if ( shouldScrub( ty ) ) {
-			PointerType * ret = new PointerType( Type::Qualifiers(), new VoidType( ty->get_qualifiers() ) );
-			delete ty;
-			return ret;
+			return new PointerType{ Type::Qualifiers(), new VoidType( ty->get_qualifiers() ) };
 		}
 		return ty;
@@ -104,6 +94,4 @@
 			Type * ret = dynType->acceptMutator( *visitor );
 			ret->get_qualifiers() |= pointer->get_qualifiers();
-			pointer->base = nullptr;
-			delete pointer;
 			return ret;
 		}
Index: src/GenPoly/Specialize.cc
===================================================================
--- src/GenPoly/Specialize.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/GenPoly/Specialize.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -193,5 +193,4 @@
 				explodeSimple( new TupleIndexExpr( expr->clone(), i ), out );
 			}
-			delete expr;
 		} else {
 			// non-tuple type - output a clone of the expression
Index: src/InitTweak/FixGlobalInit.cc
===================================================================
--- src/InitTweak/FixGlobalInit.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/InitTweak/FixGlobalInit.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -57,13 +57,9 @@
 		GlobalFixer & fixer = visitor.pass;
 		// don't need to include function if it's empty
-		if ( fixer.initFunction->get_statements()->get_kids().empty() ) {
-			delete fixer.initFunction;
-		} else {
+		if ( ! fixer.initFunction->get_statements()->get_kids().empty() ) {
 			translationUnit.push_back( fixer.initFunction );
 		} // if
 
-		if ( fixer.destroyFunction->get_statements()->get_kids().empty() ) {
-			delete fixer.destroyFunction;
-		} else {
+		if ( ! fixer.destroyFunction->get_statements()->get_kids().empty() ) {
 			translationUnit.push_back( fixer.destroyFunction );
 		} // if
@@ -130,5 +126,4 @@
 				objDecl->set_init( NULL );
 			} // if
-			delete ctorInit;
 		} // if
 	}
Index: src/InitTweak/FixInit.cc
===================================================================
--- src/InitTweak/FixInit.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/InitTweak/FixInit.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -454,5 +454,4 @@
 				resolved->env = nullptr;
 			} // if
-			delete stmt;
 			if ( TupleAssignExpr * assign = dynamic_cast< TupleAssignExpr * >( resolved ) ) {
 				// fix newly generated StmtExpr
@@ -554,8 +553,5 @@
 				result = result->clone();
 				env->apply( result );
-				if ( ! InitTweak::isConstructable( result ) ) {
-					delete result;
-					return;
-				}
+				if ( ! InitTweak::isConstructable( result ) ) return;
 
 				// create variable that will hold the result of the stmt expr
@@ -652,5 +648,4 @@
 			std::swap( impCpCtorExpr->env, callExpr->env );
 			assert( impCpCtorExpr->env == nullptr );
-			delete impCpCtorExpr;
 
 			if ( returnDecl ) {
@@ -711,7 +706,5 @@
 			if ( unqMap.count( unqExpr->get_id() ) ) {
 				// take data from other UniqueExpr to ensure consistency
-				delete unqExpr->get_expr();
 				unqExpr->set_expr( unqMap[unqExpr->get_id()]->get_expr()->clone() );
-				delete unqExpr->get_result();
 				unqExpr->set_result( maybeClone( unqExpr->get_expr()->get_result() ) );
 				if ( unqCount[ unqExpr->get_id() ] == 0 ) {  // insert destructor after the last use of the unique expression
@@ -824,7 +817,8 @@
 							// create a new object which is never used
 							static UniqueName dummyNamer( "_dummy" );
-							ObjectDecl * dummy = new ObjectDecl( dummyNamer.newName(), Type::StorageClasses( Type::Static ), LinkageSpec::Cforall, 0, new PointerType( Type::Qualifiers(), new VoidType( Type::Qualifiers() ) ), 0, std::list< Attribute * >{ new Attribute("unused") } );
-							delete ctorInit;
-							return dummy;
+							return new ObjectDecl{
+								dummyNamer.newName(), Type::StorageClasses( Type::Static ), LinkageSpec::Cforall, 0, 
+								new PointerType{ Type::Qualifiers(), new VoidType( Type::Qualifiers() ) }, 
+								0, std::list< Attribute * >{ new Attribute("unused") } };
 						}
 					} else {
@@ -852,5 +846,4 @@
 					objDecl->init = nullptr;
 				} // if
-				delete ctorInit;
 			} // if
 			return objDecl;
@@ -1228,5 +1221,4 @@
 			ObjectDecl * tmp = ObjectDecl::newObject( tempNamer.newName(), callExpr->args.front()->result->clone(), nullptr );
 			declsToAddBefore.push_back( tmp );
-			delete ctorExpr;
 
 			// build assignment and replace constructor's first argument with new temporary
@@ -1237,5 +1229,4 @@
 			// resolve assignment and dispose of new env
 			ResolvExpr::findVoidExpression( assign, indexer );
-			delete assign->env;
 			assign->env = nullptr;
 
Index: src/InitTweak/InitTweak.cc
===================================================================
--- src/InitTweak/InitTweak.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/InitTweak/InitTweak.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -122,5 +122,5 @@
 	public:
 		ExprImpl( Expression * expr ) : arg( expr ) {}
-		virtual ~ExprImpl() { delete arg; }
+		virtual ~ExprImp() = default;
 
 		virtual std::list< Expression * > next( std::list< Expression * > & indices ) {
@@ -166,5 +166,4 @@
 
 	void InitExpander::clearArrayIndices() {
-		deleteAll( indices );
 		indices.clear();
 	}
@@ -263,5 +262,4 @@
 		build( dst, indices.begin(), indices.end(), init, back_inserter( block->get_kids() ) );
 		if ( block->get_kids().empty() ) {
-			delete block;
 			return nullptr;
 		} else {
Index: src/MakeLibCfa.cc
===================================================================
--- src/MakeLibCfa.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/MakeLibCfa.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -65,10 +65,8 @@
 		struct ZeroOneReplacer {
 			ZeroOneReplacer( Type * t ) : type( t ) {}
-			~ZeroOneReplacer() { delete type; }
 			Type * type = nullptr;
 
 			Type * common( Type * t ) {
 				if ( ! type ) return t;
-				delete t;
 				return type->clone();
 			}
Index: src/Parser/DeclarationNode.cc
===================================================================
--- src/Parser/DeclarationNode.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Parser/DeclarationNode.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -986,5 +986,4 @@
 					obj->location = cur->location;
 					* out++ = obj;
-					delete agg;
 				} else if ( UnionDecl * agg = dynamic_cast< UnionDecl * >( decl ) ) {
 					UnionInstType * inst = new UnionInstType( Type::Qualifiers(), agg->get_name() );
Index: src/Parser/ExpressionNode.cc
===================================================================
--- src/Parser/ExpressionNode.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Parser/ExpressionNode.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -427,5 +427,4 @@
 	Type * targetType = maybeMoveBuildType( decl_node );
 	if ( dynamic_cast< VoidType * >( targetType ) ) {
-		delete targetType;
 		return new CastExpr( maybeMoveBuild< Expression >(expr_node) );
 	} else {
@@ -451,7 +450,5 @@
 
 Expression * build_offsetOf( DeclarationNode * decl_node, NameExpr * member ) {
-	Expression * ret = new UntypedOffsetofExpr( maybeMoveBuildType( decl_node ), member->get_name() );
-	delete member;
-	return ret;
+	return new UntypedOffsetofExpr{ maybeMoveBuildType( decl_node ), member->get_name() };
 } // build_offsetOf
 
Index: src/ResolvExpr/AdjustExprType.cc
===================================================================
--- src/ResolvExpr/AdjustExprType.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/ResolvExpr/AdjustExprType.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -66,12 +66,9 @@
 
 	Type * AdjustExprType::postmutate( ArrayType * arrayType ) {
-		PointerType *pointerType = new PointerType( arrayType->get_qualifiers(), arrayType->base );
-		arrayType->base = nullptr;
-		delete arrayType;
-		return pointerType;
+		return new PointerType{ arrayType->get_qualifiers(), arrayType->base };
 	}
 
 	Type * AdjustExprType::postmutate( FunctionType * functionType ) {
-		return new PointerType( Type::Qualifiers(), functionType );
+		return new PointerType{ Type::Qualifiers(), functionType };
 	}
 
@@ -80,12 +77,10 @@
 		if ( env.lookup( typeInst->get_name(), eqvClass ) ) {
 			if ( eqvClass.data.kind == TypeDecl::Ftype ) {
-				PointerType *pointerType = new PointerType( Type::Qualifiers(), typeInst );
-				return pointerType;
+				return new PointerType{ Type::Qualifiers(), typeInst };
 			}
 		} else if ( NamedTypeDecl *ntDecl = indexer.lookupType( typeInst->get_name() ) ) {
 			if ( TypeDecl *tyDecl = dynamic_cast< TypeDecl* >( ntDecl ) ) {
 				if ( tyDecl->get_kind() == TypeDecl::Ftype ) {
-					PointerType *pointerType = new PointerType( Type::Qualifiers(), typeInst );
-					return pointerType;
+					return new PointerType{ Type::Qualifiers(), typeInst };
 				} // if
 			} // if
